    Module cox_selection
!     .. Implicit None Statement ..
      Implicit None
!     .. Interface Blocks ..
      Interface
        Subroutine forward_selection(z,isz,t,ic,pa,dev,b,se,sc,cov,res,nd,tp, &
          sur,info,nout)
!         .. Use Statements ..
          Use nag_library, Only: wp => nag_wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: dev
          Real (Kind=wp), Intent (In) :: pa
          Integer, Intent (Out) :: nd
          Integer, Optional, Intent (In) :: nout
!         .. Array Arguments ..
          Real (Kind=wp), Allocatable, Intent (Out) :: b(:), cov(:), res(:), &
            sc(:), se(:), sur(:,:), tp(:)
          Real (Kind=wp), Intent (In) :: t(:), z(:,:)
          Integer, Intent (In) :: ic(:)
          Integer, Intent (Out) :: info(4)
          Integer, Intent (Inout) :: isz(:)
        End Subroutine forward_selection
        Subroutine backward_selection(z,isz,t,ic,pd,dev,b,se,sc,cov,res,nd,tp, &
          sur,info,nout)
!         .. Use Statements ..
          Use nag_library, Only: wp => nag_wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: dev
          Real (Kind=wp), Intent (In) :: pd
          Integer, Intent (Out) :: nd
          Integer, Optional, Intent (In) :: nout
!         .. Array Arguments ..
          Real (Kind=wp), Allocatable, Intent (Out) :: b(:), cov(:), res(:), &
            sc(:), se(:), sur(:,:), tp(:)
          Real (Kind=wp), Intent (In) :: t(:), z(:,:)
          Integer, Intent (In) :: ic(:)
          Integer, Intent (Out) :: info(4)
          Integer, Intent (Inout) :: isz(:)
        End Subroutine backward_selection
        Subroutine stepwise_selection(z,isz,t,ic,pa,pd,dev,b,se,sc,cov,res,nd, &
          tp,sur,info,nout)
!         .. Use Statements ..
          Use nag_library, Only: wp => nag_wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: dev
          Real (Kind=wp), Intent (In) :: pa, pd
          Integer, Intent (Out) :: nd
          Integer, Optional, Intent (In) :: nout
!         .. Array Arguments ..
          Real (Kind=wp), Allocatable, Intent (Out) :: b(:), cov(:), res(:), &
            sc(:), se(:), sur(:,:), tp(:)
          Real (Kind=wp), Intent (In) :: t(:), z(:,:)
          Integer, Intent (In) :: ic(:)
          Integer, Intent (Out) :: info(4)
          Integer, Intent (Inout) :: isz(:)
        End Subroutine stepwise_selection
        Function score_test_statistic(sc,cov)
!         .. Use Statements ..
          Use nag_library, Only: wp => nag_wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: score_test_statistic
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: cov(:), sc(:)
        End Function score_test_statistic
        Function wald_test_statistic(b,cov)
!         .. Use Statements ..
          Use nag_library, Only: wp => nag_wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: wald_test_statistic
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(:), cov(:)
        End Function wald_test_statistic
        Subroutine fit_coxph(z,isz,t,ic,dev,b,se,sc,cov,res,nd,tp,sur,ifail, &
          omega,isi,tol,maxit,iprint,est_init)
!         .. Use Statements ..
          Use nag_library, Only: wp => nag_wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: dev
          Real (Kind=wp), Optional, Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Optional, Intent (In) :: iprint, maxit
          Integer, Intent (Out) :: nd
          Logical, Optional, Intent (In) :: est_init
!         .. Array Arguments ..
          Real (Kind=wp), Allocatable, Intent (Inout) :: b(:)
          Real (Kind=wp), Allocatable, Intent (Out) :: cov(:), res(:), sc(:), &
            se(:), sur(:,:), tp(:)
          Real (Kind=wp), Optional, Intent (In) :: omega(:)
          Real (Kind=wp), Intent (In) :: t(:), z(:,:)
          Integer, Intent (In) :: ic(:), isz(:)
          Integer, Optional, Intent (In) :: isi(:)
        End Subroutine fit_coxph
        Subroutine estimate_initial_b(z,isz,t,ic,ib)
!         .. Use Statements ..
          Use nag_library, Only: wp => nag_wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Array Arguments ..
          Real (Kind=wp), Allocatable, Intent (Out) :: ib(:)
          Real (Kind=wp), Intent (In) :: t(:), z(:,:)
          Integer, Intent (In) :: ic(:), isz(:)
        End Subroutine estimate_initial_b
        Subroutine select_var_to_add(z,isz,t,ic,pa,cisz,ib,addvar,info,nout, &
          monit)
!         .. Use Statements ..
          Use nag_library, Only: wp => nag_wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: pa
          Integer, Intent (Out) :: addvar
          Integer, Intent (In) :: nout
          Logical, Intent (In) :: monit
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ib(:)
          Real (Kind=wp), Intent (In) :: t(:), z(:,:)
          Integer, Intent (Inout) :: cisz(:), info(4)
          Integer, Intent (In) :: ic(:), isz(:)
        End Subroutine select_var_to_add
        Subroutine select_var_to_drop(pd,cisz,b,se,dropvar,info,nout,monit)
!         .. Use Statements ..
          Use nag_library, Only: wp => nag_wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: pd
          Integer, Intent (Out) :: dropvar
          Integer, Intent (In) :: nout
          Logical, Intent (In) :: monit
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(:), se(:)
          Integer, Intent (Inout) :: cisz(:), info(4)
        End Subroutine select_var_to_drop
      End Interface
    End Module cox_selection

    Program g12bafe_selection
!     Example program to demonstrate one possible way of implementing forward, 
!     backwards and stepwise variable selection using G12BAF

!     .. Use Statements ..
      Use nag_library, Only: g01ecf, g01faf, wp => nag_wp
      Use cox_selection, Only: backward_selection, forward_selection,          &
                               stepwise_selection, wald_test_statistic
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter               :: nin = 5, nout = 6
!     .. Local Scalars ..
      Real (Kind=wp)                   :: adj, dev, df, hazard, hazard_lci,    &
                                          hazard_uci, p, pa, pd, w
      Integer                          :: i, ierr, m, mnout, n, nd, v
      Logical                          :: monit, wacc
      Character (200)                  :: line
      Character (1)                    :: method
!     .. Local Arrays ..
      Real (Kind=wp), Allocatable      :: b(:), cov(:), res(:), sc(:), se(:),  &
                                          sur(:,:), t(:), tp(:), z(:,:)
      Integer, Allocatable             :: ic(:), isz(:)
      Integer                          :: info(4)
!     .. Intrinsic Procedures ..
      Intrinsic                        :: count, exp, len_trim, nint, real,    &
                                          repeat, trim
!     .. Executable Statements ..
      Continue

!     skip heading in data file
      Read (nin,*)

!     read in the type of variable selection to use
!     F = forwards, B = backwards and S = stepwise
      Read (nin,*) method

!     read in the parameters that control the fitting process
      Select Case (method)
      Case ('F','f')
        Read (nin,*) pa

      Case ('B','b')
        Read (nin,*) pd

      Case ('S','s')
        Read (nin,*) pa, pd

      Case Default
        Write (nout,*) 'Unknown variable selection method, method = ', method
        Stop
      End Select

!     read in monitoring flag
      Read (nin,*) monit

!     read in problem size
      Read (*,*) n, m

      Allocate (z(n,m),isz(m),t(n),ic(n))

!     read in the variable indication, this indicates which variables to 
!     include in the selection process, with ISZ(i) = 1 indicating that
!     the i'th variable is to be considered in the process and ISZ(i) = 0
!     indicating that it is not considered
      Read (*,*) isz(1:m)

!     read in the data
      Read (*,*)(t(i),z(i,1:m),ic(i),i=1,n)

      If (monit) Then
        mnout = nout
        Write (mnout,*) 'Number of observations          : ', n
        Write (mnout,*) 'Total no. of covariates         : ', m
        Write (mnout,*) 'Number of covariates considered : ', &
          count(isz(1:m)>=1)
        Write (mnout,*)
      Else
        mnout = 0
      End If

!     fit the Cox proportional hazards model using the specified variable
!     selection process
      Select Case (method)
      Case ('F','f')
        Call forward_selection(z,isz,t,ic,pa,dev,b,se,sc,cov,res,nd,tp,sur, &
          info,mnout)

      Case ('B','b')
        Call backward_selection(z,isz,t,ic,pd,dev,b,se,sc,cov,res,nd,tp,sur, &
          info,mnout)

      Case ('S','s')
        Call stepwise_selection(z,isz,t,ic,pa,pd,dev,b,se,sc,cov,res,nd,tp, &
          sur,info,mnout)
      End Select
!     check the error exit from the selection routine
      If (info(1)==1) Then
        Write (nout,*) 'Potential problem occurred in the selection routine'
        Write (nout,*) 'INFO = ', info(1:4)
      Else If (info(1)/=0) Then
        Write (nout,*) 'Fatal problem occurred in the selection routine'
        Write (nout,*) 'INFO = ', info(1:4)
        Stop
      End If

!     display the information for the final model
      If (count(isz(1:m)>=1)==0) Then
        Write (nout,*)
        Write (nout,'(A)') 'No covariates were included in the &
          &model, so there is no model information to display'

      Else
        Write (nout,*)
        Write (nout,99999) '          ', '          ', ' Parameter', &
          '  Standard', '          ', '          ', '    Hazard', &
          '    95% CI', '    95% CI'
        Write (line,99999) '  Covariate', '     DF', '   Estimate', &
          '     Error', 'Chi-Square', 'Pr > ChiSq', '     Ratio', &
          '     Lower', '     Upper'
        Write (nout,*) trim(line)
        Write (nout,'(2X,A)') repeat('-',len_trim(line)-1)
        i = 0
        wacc = .False.
        Do v = 1, m
          If (isz(v)==1) Then
            i = i + 1

!           Wald test statistic and degrees of freedom
!           as in the backwards selection method, this again assumes that the 
!           covariates are are continuous or binary (i.e. they have a single 
!           degree freedom). If they do not then the wald_test_statistic 
!           routine would need to be called and the degrees of freedom changed
            w = (b(i)/se(i))**2
            df = 1.0_wp

!           get the associated p-value
            ierr = 1
            p = g01ecf('Upper',w,df,ierr)
            If (ierr/=0) Then
              If (ierr/=4) Then
!               IFAIL = 4 from G01ECF is a warning about accuracy, but it still
!               returns a result so we will use it, otherwise call the routine 
!               again to trigger any messages and terminate
                Write (nout,*) 'Error in G01ECF, IFAIL = ', ierr
                Stop
              Else
!               possible lack of accuracy
                wacc = .True.
              End If
            End If

!           get the width of the 95% confidence interval
            ierr = 0
            adj = g01faf('Confidence',0.95_wp,ierr)*se(i)

!           calculate the harzard ratio estimate and associated 
!           confidence interval
            hazard = exp(b(i))
            hazard_lci = exp(b(i)-adj)
            hazard_uci = exp(b(i)+adj)

            Write (nout,99998) v, nint(df), b(i), se(i), w, p, hazard, &
              hazard_lci, hazard_uci
          End If
        End Do
        If (wacc) Then
          Write (nout,*) 'Warning: Some p-values have been flagged &
            &as having accuracy issues, displayed values'
          Write (nout,*) ' should be a good approximation'
        End If
        Write (nout,*)

!       as we have assumed that all covariates are binary or continuous we have
!       not actually used the WALD_TEST_STATISTIC routine in this example, so 
!       perform a global null hypothesis test of H0: B = 0, vs H1: B /= 0

!       get the test statistic and degrees of freedom, based on the 
!       final selected model (where B and COV come from the call to FIT_COXPH
!       above)
        w = wald_test_statistic(b,cov)
        df = real(count(isz(1:m)>=1),kind=wp)

!       get the associated p-value
        ierr = 1
        p = g01ecf('Upper',w,df,ierr)
        If (ierr/=0) Then
          If (ierr/=4) Then
!           IFAIL = 4 from G01ECF is a warning about accuracy, but it still 
!           returns a result so we will use it, otherwise call the routine 
!           again to trigger any messages and terminate
            Write (nout,*) 'Error in G01ECF, IFAIL = ', ierr
            Stop
          Else
!           possible lack of accuracy
            wacc = .True.
          End If
        End If

!       display the test
        Write (nout,*) 'Global Null Hypothesis B = 0'
        Write (nout,*) '----------------------------'
        Write (nout,*) '     Wald'
        Write (nout,*) '   Statistic         DF       p-value'
        Write (nout,*) '  -----------------------------------'
        Write (nout,99997) w, nint(df), p
        If (wacc) Then
          Write (nout,*) 'Warning: The p-value has been flagged &
            &as having accuracy issues, displayed value'
          Write (nout,*) ' should be a good approximation'
        End If
      End If

99999 Format (1X,A,3X,A,3X,A,3X,A,3X,A,3X,A,3X,A,3X,A,3X,A)
99998 Format (1X,I10,2X,I10,4X,F10.4,3X,F10.4,3X,F10.4,3X,F10.4,3X,F10.4,3X, &
        F10.4,3X,F10.4)
99997 Format (1X,F10.4,2X,I10,4X,F10.4)
    End Program g12bafe_selection

    Subroutine forward_selection(z,isz,t,ic,pa,dev,b,se,sc,cov,res,nd,tp,sur, &
      info,nout)
!     Fits a Cox proportional hazards model using a forwards selection process
!     to automatically choose which model to fit

!     The selection process uses the Score test statistic to determine which
!     covariate (if any) is added to the model at each iteration

!     Input:
!     Z, T and
!     IC   - As per G12BAF
!            The number of observations (N) is taken as the length of T
!            The number of covariates (M) is taken as the length of ISZ
!     PA   - Cut-off used when deciding whether a covariate should be included
!            in the model. If the p-value associated with the largest Score
!            test statistic <= PA then the associated covariate is included
!            in the model
!     NOUT - (Optional) If present, and NOUT > 0, then monitoring information
!            is written to the output channel NOUT, otherwise no information 
!            is printed

!     Input / Output
!     ISZ  - On entry: indicates which subset of covariates are to be included 
!            in the model selection process:
!              ISZ(j) >= 1 indicates that the jth covariate is included in the 
!                          process
!              ISZ(j) = 0  indicates that the jth covariate is ignored
!            On exit: indicates which subset of covariates are in the final model
!              ISZ(j) >= 1 indicates that the jth covariate is included in 
!                          the model
!              ISZ(j) = 0  indicates that the jth covariate is not included 
!                          in the model

!     Output:
!     DEV,B,SE,SC,COV,RES,BD,TP and
!     SUR  - As per G12BAF. These output variables are for the final model as 
!            defined by the values of ISZ on exit.
!     INFO - Warning / error information, INFO(4)
!            INFO(1) = 0 if all is OK or only a warning was issued, full output
!                         has been returned in all of the output parameters
!                    = 1 if a potential problem occurred, but output still 
!                        returned
!                    = 2 indicates that an error occurred somewhere in the 
!                        routine and no output could be returned
!                    = 3 indicates that the input arrays are not consistent in
!                        their size
!                        Information on any errors or warnings is returned in 
!                        the remaining elements of INFO
!            INFO(2) = value of IFAIL from FIT_COXPH
!            INFO(3) = value of IFAIL from G01ECF
!            INFO(4) = not used

!     .. Use Statements ..
      Use nag_library, Only: wp => nag_wp
      Use cox_selection, Only: fit_coxph, select_var_to_add
!     .. Implicit None Statement ..
      Implicit None
!     .. Scalar Arguments ..
      Real (Kind=wp), Intent (Out)     :: dev
      Real (Kind=wp), Intent (In)      :: pa
      Integer, Intent (Out)            :: nd
      Integer, Optional, Intent (In)   :: nout
!     .. Array Arguments ..
      Real (Kind=wp), Allocatable, Intent (Out) :: b(:), cov(:), res(:),       &
                                                   sc(:), se(:), sur(:,:), tp(:)
      Real (Kind=wp), Intent (In)      :: t(:), z(:,:)
      Integer, Intent (In)             :: ic(:)
      Integer, Intent (Out)            :: info(4)
      Integer, Intent (Inout)          :: isz(:)
!     .. Local Scalars ..
      Integer                          :: addvar, ierr, iter, m, max_iter,     &
                                          mnout, n
      Logical                          :: monit
      Character (100)                  :: line
!     .. Local Arrays ..
      Real (Kind=wp), Allocatable      :: ib(:)
      Integer, Allocatable             :: cisz(:)
!     .. Intrinsic Procedures ..
      Intrinsic                        :: count, len_trim, present, repeat,    &
                                          size, trim, unpack
!     .. Executable Statements ..
      Continue
      info(:) = 0

!     monitoring flag
      If (present(nout)) Then
        monit = (nout>0)
        mnout = nout
      Else
        monit = .False.
        mnout = 0
      End If

!     number of observations
      n = size(t,1)

!     number of covariates
      m = size(isz,1)

!     check consistency of the sizes of the other input arrays
      If (size(z,1)<n .Or. size(z,2)<m .Or. size(ic,1)<n) Then
        info(1) = 3
        Go To 100
      End If

!     get the maximum number of iterations, which is the number of covariates
!     that will be considered as defined by ISZ(i) >= 1
      max_iter = count(isz(1:m)>=1)

!     array to hold the covariates included in the current model
      Allocate (cisz(m))

!     array to hold the parameter estimates for the current model
!     unlike the array B, in G12BAF which only has entries for those covariates
!     in the current model, IB will have entries for all M covariates
!     and IB(i) = 0.0 if CISZ(i) = 0 (i.e. IB(i) will take a value of zero if
!     covariate i is not in the model)
      Allocate (ib(m))

!     start with the null model
      cisz(1:m) = 0
      ib(1:m) = 0.0_wp

!        loop over the number of possible models to consider
iter_lp: Do iter = 1, max_iter

        If (monit) Then
!         display a heading if we are outputing monitoring information
          Write (mnout,*)
          Write (line,'(A,I0)') 'Iteration ', iter
          Write (mnout,*) trim(line)
          Write (mnout,*) repeat('-',len_trim(line))
        End If

!       select the covariate to add
        Call select_var_to_add(z,isz,t,ic,pa,cisz,ib,addvar,info,mnout,monit)
        If (addvar<1) Then
          If (monit) Then
            Write (nout,'(A,I0)') &
              'No covariates added to the model at iteration ', iter
            Write (mnout,'(A)') 'Terminating selection process'
          End If
          Exit iter_lp
        End If

        If (monit) Then
          Write (nout,'(A,I0,A,I0)') 'Covariate ', addvar, &
            ' added to the model at iteration ', iter
        End If

!       quiet exit from NAG routine
        ierr = 1

!       fit the current model (use default values for all the optional arguments)
        Call fit_coxph(z,cisz,t,ic,dev,b,se,sc,cov,res,nd,tp,sur,ierr)
        If (ierr/=0) Then
          info(2) = ierr
          If (ierr<5) Then
            info(1) = 2
            Exit iter_lp
          End If
          info(1) = 1
!         IERR = 5 or 6 indicate possible non-covergence, but the full results
!         will have been returned, so continue
        End If

!       copy the parameter estimates from the current model into IB, so IB(i) 
!       will take a value from B if CISZ(i) >= 1 and remain unchanged otherwise
!       (which means it will be 0). If CISZ(i) >= 1 and it is the jth value of 
!       1 in CISZ  (i.e. count(CISZ(1:i)>=1) = j), then IB(i) = B(j)
        ib = unpack(b,(cisz(1:m)>=1),ib)
      End Do iter_lp

!     update the information in ISZ to the last model
      isz(1:m) = cisz(1:m)

100   Continue

!     deallocate the local allocatable arrays
      Deallocate (cisz,Stat=ierr)
      Deallocate (ib,Stat=ierr)

      Return
    End Subroutine forward_selection

    Subroutine backward_selection(z,isz,t,ic,pd,dev,b,se,sc,cov,res,nd,tp,sur, &
      info,nout)
!     Fits a Cox proportional hazards model using a backwards selection process
!     to automatically choose which model to fit

!     The selection process uses the Wald test statistic to determine which
!     covariate (if any) is added to the model at each iteration

!     Input:
!     Z, T and
!     IC   - As per G12BAF
!            The number of observations (N) is taken as the length of T
!            The number of covariates (M) is taken as the length of ISZ
!     PD   - Cut-off used when deciding whether a covariate should be dropped
!            from the model. If the p-value associated with the smallest Score
!            test statistic > PD then the associated covariate is dropped
!            from the model
!     NOUT - (Optional) If present, and NOUT > 0, then monitoring information
!            is written to the output channel NOUT, otherwise no information 
!            is printed

!     Input / Output
!     ISZ  - On entry: indicates which subset of covariates are to be included 
!            in the model selection process:
!              ISZ(j) >= 1 indicates that the jth covariate is included in 
!                          the process
!              ISZ(j) = 0  indicates that the jth covariate is ignored
!            On exit: indicates which subset of covariates are in the final model
!              ISZ(j) >= 1 indicates that the jth covariate is included in 
!                          the model
!              ISZ(j) = 0  indicates that the jth covariate is not included 
!                          in the model

!     Output:
!     DEV,B,SE,SC,COV,RES,BD,TP and
!     SUR  - As per G12BAF. These output arguments are for the final model as 
!            defined by the values of ISZ on exit.
!     INFO - Warning / error information, INFO(4)
!            INFO(1) = 0 if all is OK or only a warning was issued, full output
!                         has been returned in all of the output parameters
!                    = 1 if a potential problem occurred, but output still 
!                        returned
!                    = 2 indicates that an error occurred somewhere in the 
!                        routine and no output could be returned
!                    = 3 indicates that the input arrays are not consistent in
!                        their size
!                        Information on any errors or warnings is returned in 
!                        the remaining elements of INFO
!            INFO(2) = value of IFAIL from FIT_COXPH
!            INFO(3) = value of IFAIL from G01ECF
!            INFO(4) = 1 if an error occurred whilst calculating the Wald test
!                      statistic, otherwise a value of 0 is returned

!     .. Use Statements ..
      Use nag_library, Only: wp => nag_wp
      Use cox_selection, Only: fit_coxph, select_var_to_drop
!     .. Implicit None Statement ..
      Implicit None
!     .. Scalar Arguments ..
      Real (Kind=wp), Intent (Out)     :: dev
      Real (Kind=wp), Intent (In)      :: pd
      Integer, Intent (Out)            :: nd
      Integer, Optional, Intent (In)   :: nout
!     .. Array Arguments ..
      Real (Kind=wp), Allocatable, Intent (Out) :: b(:), cov(:), res(:),       &
                                                   sc(:), se(:), sur(:,:), tp(:)
      Real (Kind=wp), Intent (In)      :: t(:), z(:,:)
      Integer, Intent (In)             :: ic(:)
      Integer, Intent (Out)            :: info(4)
      Integer, Intent (Inout)          :: isz(:)
!     .. Local Scalars ..
      Integer                          :: dropvar, ierr, iter, m, max_iter, n
      Logical                          :: monit
      Character (80)                   :: line
!     .. Local Arrays ..
      Integer, Allocatable             :: cisz(:)
!     .. Intrinsic Procedures ..
      Intrinsic                        :: count, len_trim, present, repeat,    &
                                          size, trim
!     .. Executable Statements ..
      Continue
      info(:) = 0

!     monitoring flag
      If (present(nout)) Then
        monit = (nout>0)
      Else
        monit = .False.
      End If

!     number of observations
      n = size(t,1)

!     number of covariates
      m = size(isz,1)

!     check consistency of the sizes of the other input arrays
      If (size(z,1)<n .Or. size(z,2)<m .Or. size(ic,1)<n) Then
        info(1) = 3
        Go To 100
      End If

!     get the maximum number of iterations, which is the number of covariates
!     that will be considered as defined by ISZ(i) = 1
      max_iter = count(isz(1:m)>=1)

!     array to hold the covariates included in the current model
      Allocate (cisz(m))

!     start with the full model
      cisz(1:m) = isz(1:m)

!        loop over the number of possible models to consider
iter_lp: Do iter = 1, max_iter

!       quiet exit from NAG routine
        ierr = 1

!       fit the current model (use default values for all the optional arguments)
        Call fit_coxph(z,cisz,t,ic,dev,b,se,sc,cov,res,nd,tp,sur,ierr)
        If (ierr/=0) Then
          info(2) = ierr
          If (ierr<5) Then
            info(1) = 2
            Exit iter_lp
          End If
          info(1) = 1
!         IERR = 5 or 6 indicate possible non-covergence, but the full results 
!         will have been returned, so continue
        End If

        If (monit) Then
!         display a heading if we are outputing monitoring information
          Write (nout,*)
          Write (line,'(A,I0)') 'Iteration ', iter
          Write (nout,*) trim(line)
          Write (nout,*) repeat('-',len_trim(line))
        End If

!       select the covariate to drop
        Call select_var_to_drop(pd,cisz,b,se,dropvar,info,nout,monit)
        If (dropvar<1) Then
          If (monit) Then
            Write (nout,'(A,I0)') &
              'No covariates dropped from the model at iteration ', iter
            Write (nout,'(A)') 'Terminating selection process'
          End If
          Exit iter_lp
        End If

        If (monit) Then
          Write (nout,'(A,I0,A,I0)') 'Covariate ', dropvar, &
            ' dropped from the model at iteration ', iter
        End If

      End Do iter_lp

!     update the information in ISZ to the last model
      isz(1:m) = cisz(1:m)

100   Continue

!     deallocate the local allocatable arrays
      Deallocate (cisz,Stat=ierr)

      Return
    End Subroutine backward_selection

    Subroutine stepwise_selection(z,isz,t,ic,pa,pd,dev,b,se,sc,cov,res,nd,tp, &
      sur,info,nout)
!     Fits a Cox proportional hazards model using a stepwise selection process
!     to automatically choose which model to fit

!     The selection process uses the Score test statistic to determine which
!     covariate (if any) is added to the model and the Wald
!     test statistic to determine which covariate (if any) is dropped from
!     the model at each iteration

!     Input:
!     Z, T and
!     IC   - As per G12BAF
!            The number of observations (N) is taken as the length of T
!            The number of covariates (M) is taken as the length of ISZ
!     PA   - Cut-off used when deciding whether a covariate should be included
!            in the model. If the p-value associated with the largest Score
!            test statistic <= PA then the associated covariate is included
!            in the model
!     PD   - Cut-off used when deciding whether a covariate should be dropped
!            from the model. If the p-value associated with the largest Score
!            test statistic > PD then the associated covariate is dropped
!            from the model
!     NOUT - (Optional) If present, and NOUT > 0, then monitoring information
!            is written to the output channel NOUT, otherwise no information 
!            is printed

!     Input / Output
!     ISZ  - On entry: indicates which subset of covariates are to be included
!            in the model selection process:
!              ISZ(j) >= 1 indicates that the jth covariate is included in 
!                          the process
!              ISZ(j) = 0  indicates that the jth covariate is ignored
!            On exit: indicates which subset of covariates are in the final model
!              ISZ(j) >= 1 indicates that the jth covariate is included in 
!                          the model
!              ISZ(j) = 0  indicates that the jth covariate is not included 
!                          in the model

!     Output:
!     DEV,B,SE,SC,COV,RES,BD,TP and
!     SUR  - As per G12BAF. These output variables are for the final model 
!            as defined by the values of ISZ on exit.
!     INFO - Warning / error information, INFO(4)
!            INFO(1) = 0 if all is OK or only a warning was issued, full output
!                         has been returned in all of the output parameters
!                    = 1 if a potential problem occurred, but output still 
!                        returned
!                    = 2 indicates that an error occurred somewhere in the 
!                        routine and no output could be returned
!                    = 3 indicates that the input arrays are not consistent in
!                        their size
!                        Information on any errors or warnings is returned in 
!                        the remaining elements of INFO
!            INFO(2) = value of IFAIL from FIT_COXPH
!            INFO(3) = value of IFAIL from G01ECF
!            INFO(4) = 1 if an error occurred whilst calculating the Wald test
!                      statistic, otherwise a value of 0 is returned

!     .. Use Statements ..
      Use nag_library, Only: wp => nag_wp
      Use cox_selection, Only: fit_coxph, select_var_to_add, select_var_to_drop
!     .. Implicit None Statement ..
      Implicit None
!     .. Scalar Arguments ..
      Real (Kind=wp), Intent (Out)     :: dev
      Real (Kind=wp), Intent (In)      :: pa, pd
      Integer, Intent (Out)            :: nd
      Integer, Optional, Intent (In)   :: nout
!     .. Array Arguments ..
      Real (Kind=wp), Allocatable, Intent (Out) :: b(:), cov(:), res(:),       &
                                                   sc(:), se(:), sur(:,:), tp(:)
      Real (Kind=wp), Intent (In)      :: t(:), z(:,:)
      Integer, Intent (In)             :: ic(:)
      Integer, Intent (Out)            :: info(4)
      Integer, Intent (Inout)          :: isz(:)
!     .. Local Scalars ..
      Integer                          :: addvar, dropvar, ierr, iter, m,      &
                                          max_iter, mnout, n
      Logical                          :: monit
      Character (100)                  :: line
!     .. Local Arrays ..
      Real (Kind=wp), Allocatable      :: ib(:)
      Integer, Allocatable             :: cisz(:)
!     .. Intrinsic Procedures ..
      Intrinsic                        :: count, len_trim, present, repeat,    &
                                          size, trim, unpack
!     .. Executable Statements ..
      Continue
      info(:) = 0

!     monitoring flag
      If (present(nout)) Then
        monit = (nout>0)
        mnout = nout
      Else
        monit = .False.
        mnout = 0
      End If

!     number of observations
      n = size(t,1)

!     number of covariates
      m = size(isz,1)

!     check consistency of the sizes of the other input arrays
      If (size(z,1)<n .Or. size(z,2)<m .Or. size(ic,1)<n) Then
        info(1) = 3
        Go To 100
      End If

!     get the maximum number of iterations, which is the number of covariates
!     that will be considered as defined by ISZ(i) >= 1
      max_iter = count(isz(1:m)>=1)

!     array to hold the covariates included in the current model
      Allocate (cisz(m))

!     array to hold the parameter estimates for the current model
!     unlike the array B, in G12BAF which only has entries for those covariates
!     in the current model, IB will have entries for all M covariates
!     and IB(i) = 0.0 if CISZ(i) = 0 (i.e. IB(i) will take a value of zero if
!     covariate i is not in the model)
      Allocate (ib(m))

!     start with the null model
      cisz(1:m) = 0
      ib(1:m) = 0.0_wp

!        loop over the number of possible models to consider
iter_lp: Do iter = 1, max_iter

        If (monit) Then
!         display a heading if we are outputing monitoring information
          Write (mnout,*)
          Write (line,'(A,I0)') 'Iteration ', iter
          Write (mnout,*) trim(line)
          Write (mnout,*) repeat('-',len_trim(line))
          Write (mnout,*)
          Write (line,'(A)') 'Forwards Step'
          Write (mnout,*) trim(line)
          Write (mnout,*) repeat('-',len_trim(line))
        End If

!       select the covariate to add
        Call select_var_to_add(z,isz,t,ic,pa,cisz,ib,addvar,info,mnout,monit)
        If (addvar<1) Then
          If (monit) Then
            Write (nout,'(A,I0)') &
              'No covariates added to the model at iteration ', iter
            Write (mnout,'(A)') 'Terminating selection process'
          End If
          Exit iter_lp
        End If

        If (monit) Then
          Write (nout,'(A,I0,A,I0)') 'Covariate ', addvar, &
            ' added to the model at iteration ', iter
        End If

!       quiet exit from NAG routine
        ierr = 1

!       fit the current model (use default values for all the optional arguments)
        Call fit_coxph(z,cisz,t,ic,dev,b,se,sc,cov,res,nd,tp,sur,ierr)
        If (ierr/=0) Then
          info(2) = ierr
          If (ierr<5) Then
            info(1) = 2
            Exit iter_lp
          End If
          info(1) = 1
!         IERR = 5 or 6 indicate possible non-covergence, but the full results
!         will have been returned, so continue
        End If

!       copy the parameter estimates from the current model into IB, so IB(i) 
!       will take a value from B if CISZ(i) >= 1 and remain unchanged otherwise
!       (which means it will be 0). If CISZ(i) >= 1 and it is the jth value of 
!       1 in CISZ  (i.e. count(CISZ(1:i)>=1) = j), then IB(i) = B(j)
        ib = unpack(b,(cisz(1:m)>=1),ib)

        If (monit) Then
          Write (mnout,*)
          Write (line,'(A)') 'Backwards Step'
          Write (mnout,*) trim(line)
          Write (mnout,*) repeat('-',len_trim(line))
        End If

!       select the covariate to drop
        Call select_var_to_drop(pd,cisz,b,se,dropvar,info,nout,monit)
        If (monit) Then
          If (dropvar<1) Then
            Write (nout,'(A,I0)') &
              'No covariates dropped from the model at iteration ', iter
          Else
            Write (nout,'(A,I0,A,I0)') 'Covariate ', dropvar, &
              ' dropped from the model at iteration ', iter
          End If
        End If

!       check that we havn't dropped the same variable as we just added
        If (dropvar==addvar) Then
          If (monit) Then
            Write (nout,'(A)') &
              'The same covariate was added and dropped at this iteration'
            Write (nout,'(A)') 'Terminating selection process'
          End If

!         we have not called FIT_COXPH on the current model, the last call
!         was with DROPVAR included in the model, so if there are some
!         variables in this model we need to call FIT_COXPH again
          If (count(cisz(1:m)>=1)>0) Then
            Call fit_coxph(z,cisz,t,ic,dev,b,se,sc,cov,res,nd,tp,sur,ierr)
            If (ierr/=0) Then
              info(2) = ierr
              If (ierr<5) Then
                info(1) = 2
              Else
                info(1) = 1
              End If
            End If
          End If

          Exit iter_lp
        End If

      End Do iter_lp

!     update the information in ISZ to the last model
      isz(1:m) = cisz(1:m)

100   Continue

!     deallocate the local allocatable arrays
      Deallocate (cisz,Stat=ierr)
      Deallocate (ib,Stat=ierr)

      Return
    End Subroutine stepwise_selection

    Function score_test_statistic(sc,cov)
!     Calculate and return the Score test statistic, S

!     Input:
!     SC     - Value of the score function as returned by G12BAF
!     COV    - Covariance matrix, in packed format, as returned by G12BAF

!     .. Use Statements ..
      Use nag_library, Only: ddot, dspmv, wp => nag_wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Function Return Value ..
      Real (Kind=wp)                   :: score_test_statistic
!     .. Array Arguments ..
      Real (Kind=wp), Intent (In)      :: cov(:), sc(:)
!     .. Local Scalars ..
      Integer                          :: ip
!     .. Local Arrays ..
      Real (Kind=wp), Allocatable      :: covsc(:)
!     .. Intrinsic Procedures ..
      Intrinsic                        :: size
!     .. Executable Statements ..
      Continue

!     number of covariates in the current model
      ip = size(sc,1)

!     allocate some workspace
      Allocate (covsc(ip))

!     F06PEF: calculate COV * SC
      Call dspmv('Upper',ip,1.0_wp,cov,sc,1,0.0_wp,covsc,1)

!     F06EAF: calculate transpose(SC) * COV * SC
!     which gives the Score test statistic, S
      score_test_statistic = ddot(ip,sc,1,covsc,1)

      Deallocate (covsc)
      Return
    End Function score_test_statistic

    Function wald_test_statistic(b,cov)
!      Calculate and return the Wald test statistic, W

!      Input:
!      B      - Parameter estimates as returned by G12BAF
!      COV    - Covariance matrix, in packed format, as returned by G12BAF

!     .. Use Statements ..
      Use nag_library, Only: ddot, dpstrf, dtrsm, wp => nag_wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Function Return Value ..
      Real (Kind=wp)                   :: wald_test_statistic
!     .. Array Arguments ..
      Real (Kind=wp), Intent (In)      :: b(:), cov(:)
!     .. Local Scalars ..
      Real (Kind=wp)                   :: tol
      Integer                          :: i, info, ip, j, k, rank
!     .. Local Arrays ..
      Real (Kind=wp), Allocatable      :: ccov(:,:), pb(:), work(:)
      Integer, Allocatable             :: piv(:)
!     .. Intrinsic Procedures ..
      Intrinsic                        :: size
!     .. Executable Statements ..
      Continue

!     number of covariates in the current model
      ip = size(b,1)

!     copy COV from packed format to upper triangular format
      Allocate (ccov(ip,ip))
      k = 0
      Do j = 1, ip
        Do i = 1, j
          k = k + 1
          ccov(i,j) = cov(k)
        End Do
      End Do

!     use default tolerance in F07KDF
      tol = 0.0_wp

!     F07KDF: factorise COV so that COV = transpose(U) * U, where
!     CCOV = COV on entry and U on exit
      Allocate (work(2*ip),piv(ip))
      Call dpstrf('Upper',ip,ccov,ip,piv,rank,tol,work,info)
      If (info/=0) Then
!       the matrix COV is indefinite, this should not happen if 
!       this routine is called with output taken from G12BAF
!       set output to something invalid
        wald_test_statistic = -99.99_wp

      Else
!       pivot B into PB
        Allocate (pb(ip))
        Do i = 1, ip
          pb(i) = b(piv(i))
        End Do

!       F06YJF: solve CCOV x = PB for x, putting the result in PB
        Call dtrsm('Left','Upper','Transpose','NonUnit',rank,1,1.0_wp,ccov,ip, &
          pb,ip)

!       F06EAF: calculate PB.PB = transpose(B) * inverse(COV) * B,
!       which gives the Wald test statistic
        wald_test_statistic = ddot(rank,pb,1,pb,1)
      End If

      Deallocate (ccov,stat=i)
      Deallocate (pb,stat=i)
      Deallocate (work,stat=i)
      Deallocate (piv,stat=i)
      Return
    End Function wald_test_statistic

    Subroutine fit_coxph(z,isz,t,ic,dev,b,se,sc,cov,res,nd,tp,sur,ifail,omega, &
      isi,tol,maxit,iprint,est_init)
!     Fit a Cox proporational hazards model using G12BAF

!     Input:
!     Z,ISZ,T and
!     IC       - Are as per G12BAF
!     OMEGA,ISI,NDMAX,TOL,MAXIT and
!     IPRINT   - (Optional) If supplied then as per G12BAF. The default values
!                for OMEGA and ISI is not present (which translates to OFFSET='N'
!                and NS=0) and the default values for TOL,MAXIT and IPRINT
!                are 5.0E-5_wp, 1000 and 0 respectively
!     EST_INIT - (Optional) if .TRUE. then initial parameter estimates are 
!                estimated from the data using ESTIMATE_INITIAL_B, otherwise
!                they are taken from B. If MAXIT > 0 then defaults to .TRUE., 
!                otherwise
!                if MAXIT = 0 then defaults to .FALSE.
!                If EST_INIT = .FALSE. and insufficient information has been 
!                supplied in B (defined as B not being allocated, or its
!                length being too small), then the initial values are estimated

!     Other parameters that appear in the G12BAF interface:
!     N and M are taken as the SIZE(T,1) and SIZE(ISZ,1) respectively
!     LDZ is taken as SIZE(Z,1)
!     OFFSET = 'Y' if OMEGA is present and 'N' otherwise
!     NS = 0 if ISI is not present, otherwise NS = MAXVAL(ISI)

!     Input / Output:
!     B        - As per G12BAF (but see EST_INIT. If EST_INIT = .TRUE., then the
!              input values of B are ignored)

!     Output:
!     DEV,SE,SC,COV,RES,ND,TP and 
!     SUR      - As per G12BAF
!     IFAIL    - Error code: As per G12BAF

!     The output arrays need not be allocated on input, they will be 
!     (re)allocated by this routine

!     .. Use Statements ..
      Use nag_library, Only: g12baf, wp => nag_wp
      Use cox_selection, Only: estimate_initial_b
!     .. Implicit None Statement ..
      Implicit None
!     .. Scalar Arguments ..
      Real (Kind=wp), Intent (Out)     :: dev
      Real (Kind=wp), Optional, Intent (In) :: tol
      Integer, Intent (Inout)          :: ifail
      Integer, Optional, Intent (In)   :: iprint, maxit
      Integer, Intent (Out)            :: nd
      Logical, Optional, Intent (In)   :: est_init
!     .. Array Arguments ..
      Real (Kind=wp), Allocatable, Intent (Inout) :: b(:)
      Real (Kind=wp), Allocatable, Intent (Out) :: cov(:), res(:), sc(:),      &
                                                   se(:), sur(:,:), tp(:)
      Real (Kind=wp), Optional, Intent (In) :: omega(:)
      Real (Kind=wp), Intent (In)      :: t(:), z(:,:)
      Integer, Intent (In)             :: ic(:), isz(:)
      Integer, Optional, Intent (In)   :: isi(:)
!     .. Local Scalars ..
      Real (Kind=wp)                   :: mtol
      Integer                          :: ierr, ip, ldz, lisi, lomega, m,      &
                                          miprint, mmaxit, n, ndmax, ns
      Logical                          :: mest_init
      Character (1)                    :: offset
!     .. Local Arrays ..
      Real (Kind=wp), Allocatable      :: momega(:), wk(:)
      Integer, Allocatable             :: iwk(:), misi(:)
!     .. Intrinsic Procedures ..
      Intrinsic                        :: allocated, count, max, maxval,       &
                                          present, size
!     .. Executable Statements ..
      Continue

!     number of observations
      n = size(t,1)

!     number of covariates
      m = size(isz,1)

!     lead dimension of z (this is usually N)
      ldz = size(z,1)

!     calculate the number of parameters in the model
      ip = count(isz(1:m)>0)

!     handle most of the optional arguments
      If (present(omega)) Then
        lomega = size(omega,1)
        If (lomega<n) Then
          Write (*,*) 'ISI must be of length at least N'
          Stop
        End If
        Allocate (momega(n))
        momega(1:n) = omega(1:n)
        offset = 'Y'
      Else
        Allocate (momega(1))
        offset = 'N'
      End If
      If (present(isi)) Then
        lisi = size(isi,1)
        If (lisi<n) Then
          Write (*,*) 'ISI must be of length at least N'
          Stop
        End If
        Allocate (misi(n))
        misi(1:n) = isi(1:n)
        ns = maxval(isi(1:n))
      Else
        Allocate (misi(1))
        ns = 0
      End If
      If (present(tol)) Then
        mtol = tol
      Else
        mtol = 5.0E-5_wp
      End If
      If (present(maxit)) Then
        mmaxit = maxit
      Else
        mmaxit = 1000
      End If
      If (present(iprint)) Then
        miprint = iprint
      Else
        miprint = 0
      End If

      If (mmaxit==0) Then
        mest_init = .False.
      Else If (present(est_init)) Then
        mest_init = est_init
      Else
!       by default we will estimate the initial values from the data
        mest_init = .True.
      End If

      If (.Not. mest_init) Then
!       check whether sufficient information has been given to use
!       supplied values as initial estimates
        If (allocated(b)) Then
          If (size(b,1)<ip) Then
            mest_init = .True.
          End If
        Else
          mest_init = .True.
        End If
      End If

      If (mest_init) Then
!       get some initial values by fitting an exponential model
        Call estimate_initial_b(z,isz,t,ic,b)
      End If

!     allocate the rest of the output arrays
      ndmax = n

      Allocate (se(ip),sc(ip),cov(ip*(ip+1)/2),res(n),tp(ndmax),sur(ndmax,max( &
        1,ns)))

!     allocate workspace
      Allocate (wk(ip*(ip+9)/2+n),iwk(2*n))

!     fit Cox proportional hazards model
      ierr = ifail
      Call g12baf(offset,n,m,ns,z,ldz,isz,ip,t,ic,momega,misi,dev,b,se,sc,cov, &
        res,nd,tp,sur,ndmax,mtol,mmaxit,miprint,wk,iwk,ierr)

!     return the error exit from the NAG routine
      If (mmaxit==0 .And. ierr==5) Then
!       when we set MAXIT = 0 we know that G12BAF will not converge, so 
!       ignore those warning messages
        ifail = 0
      Else
        ifail = ierr
      End If

      Deallocate (wk,iwk,momega,misi)
!     not deallocating B, SE, SC, COV, RES, TP or SUR as they are output arrays
      Return
    End Subroutine fit_coxph

    Subroutine estimate_initial_b(z,isz,t,ic,ib)
!     estimate initial values for the parameter estimates of a Cox proportional
!     hazards model using an exponential model fitted via G02GCF

!     Input:
!     Z,ISZ,T and
!     IC    - As per G12BAF

!     Output:
!     IB    - Initial values to pass to G12BAF, length of IB is
!             the number of covariates in the model defined as COUNT(ISZ(1:M)>=1)
!             (i.e. number of elements in ISZ >= 1)
!     IB need not be allocated on input, it is (re)allocated by this routine

!     If G02GCF fails for any reason then IB(:) = 0.0 is returned

!     .. Use Statements ..
      Use nag_library, Only: g02gcf, wp => nag_wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Array Arguments ..
      Real (Kind=wp), Allocatable, Intent (Out) :: ib(:)
      Real (Kind=wp), Intent (In)      :: t(:), z(:,:)
      Integer, Intent (In)             :: ic(:), isz(:)
!     .. Local Scalars ..
      Real (Kind=wp)                   :: a, dev, eps, tol
      Integer                          :: i, idf, ifail, ip, iprint, irank,    &
                                          ldv, ldz, m, maxit, n
      Character (20)                   :: link, mean, offset, weight
!     .. Local Arrays ..
      Real (Kind=wp), Allocatable      :: b(:), cov(:), se(:), v(:,:), wk(:),  &
                                          wt(:), y(:)
!     .. Intrinsic Procedures ..
      Intrinsic                        :: count, log, real, size
!     .. Executable Statements ..
      Continue

!     number of observations
      n = size(t,1)

!     number of covariates
      m = size(isz,1)

!     lead dimension of z (this is usually N)
      ldz = size(z,1)

!     we are fitting a mean in the exponential model, so there is one more
!     covariate (the mean) than that specified in ISZ
      ip = count(isz(1:m)>=1) + 1

      ldv = n
      Allocate (b(ip),se(ip),cov(ip*(ip+1)/2),wk(ip*(ip+ &
        9)/2+n),v(ldv,ip+7),y(n),wt(1))

!     format data in the way G02GCF expects
      Do i = 1, n
        y(i) = 1.0E0_wp - real(ic(i),kind=wp)
        v(i,7) = log(t(i))
      End Do

!     unweighted, log link, with mean and offset
      link = 'LogLink'
      mean = 'Mean'
      offset = 'YesUseOffset'
      weight = 'Unweighted'
      a = 0.0_wp

!     use default values for control parameters
      tol = 0.0_wp
      maxit = 0
      eps = 0.0_wp

!     no printing
      iprint = 0

!     fit exponential model
      Call g02gcf(link,mean,offset,weight,n,z,ldz,m,isz,ip,y,wt,a,dev,idf,b, &
        irank,se,cov,v,ldv,tol,maxit,iprint,eps,wk,ifail)

!     allocate output array
      Allocate (ib(ip-1))

      If (ifail/=0 .And. ifail<7) Then
!       the exponential routine has failed, so just use 0 as the initial values
        ib(:) = 0.0_wp
      Else
!       move all parameter estimates down one so as to drop the parameter
!       estimate for the mean
        ib(:) = b(2:ip)
      End If

!     deallocate the temporary arrays we no longer require
      Deallocate (b,se,cov,wk,v,y,wt)

      Return
    End Subroutine estimate_initial_b

    Subroutine select_var_to_add(z,isz,t,ic,pa,cisz,ib,addvar,info,nout,monit)
!     Select a covariate to add to a Cox proportional hazards model using the
!     Score statistic and its associated p-value

!     Input:
!     Z,T,IC and
!     PA    - As per FORWARD_SELECTION
!     ISZ   - As described in FORWARD_SELECTION, on entry
!     CISZ  - On entry: indicates which subset of covariates are in the current
!             model, with
!              CISZ(j) >= 1 indicating that the jth covariate is in the current
!                          model
!              CISZ(j) = 0  indicating that the jth covariate is not in the
!                          current model
!             On exit: as per entry, but if ADDVAR >= 1, then CISZ(ADDVAR) 
!             will have been set to 1 as well (i.e. on exit CISZ indicates
!             the covariates included in the new model, with covariate
!             indicated by ADDVAR having been added)
!     IB    - Parameter estimates, based on the current model as described
!             by CISZ. IB is of length M and contains values for all covariates.
!             If covariate j is not in the current model then IB(j) = 0.0
!             (this is a different structure to the parameter B in G12BAF
!             which only contains values for the IP covariates in the model
!             where IP would be equal to COUNT(CISZ(1:M)>=1))
!     NOUT  - As per FORWARD_SELECTION, but not optional. Not referenced if
!             MONIT = .FALSE.
!     MONIT - Logical flag indicating whether monitoring information should
!             be printed to NOUT (.TRUE.) or not (.FALSE.)

!     Output:
!     ADDVAR - The covariate to add to the model, If ADDVAR > 0 then
!              1 <= ADDVAR <= M, where M = SIZE(ISZ,1) (the number 
!              of covariates we have data for). If ADDVAR < 1 then
!              no covariates satisfied the criteria defined by PA
!              and so no covariate was added to the model
!     INFO    - As per FORWARD_SELECTION

!     .. Use Statements ..
      Use nag_library, Only: g01ecf, wp => nag_wp
      Use cox_selection, Only: fit_coxph, score_test_statistic
!     .. Implicit None Statement ..
      Implicit None
!     .. Scalar Arguments ..
      Real (Kind=wp), Intent (In)      :: pa
      Integer, Intent (Out)            :: addvar
      Integer, Intent (In)             :: nout
      Logical, Intent (In)             :: monit
!     .. Array Arguments ..
      Real (Kind=wp), Intent (Inout)   :: ib(:)
      Real (Kind=wp), Intent (In)      :: t(:), z(:,:)
      Integer, Intent (Inout)          :: cisz(:), info(4)
      Integer, Intent (In)             :: ic(:), isz(:)
!     .. Local Scalars ..
      Real (Kind=wp)                   :: dev, df, max_s, p, s
      Integer                          :: cip, ierr, ip, j, m, mj, nd
      Logical                          :: wacc
!     .. Local Arrays ..
      Real (Kind=wp), Allocatable      :: b(:), cov(:), res(:), sc(:), se(:),  &
                                          sur(:,:), tp(:)
!     .. Intrinsic Procedures ..
      Intrinsic                        :: count, pack, size
!     .. Executable Statements ..
      Continue

!     number of covariates
      m = size(isz,1)

!     get the number of covariates in the current model
      ip = count(cisz(1:m)>=1)

!     initialise the variable holding the maximum score (MAX_S), the
!     associated covariate (MJ) and the variable to add
      max_s = 0.0_wp
      mj = 0
      addvar = -1

!     we will be considering a model with one additional covariate
!     this assumes that all the covariates are continous or binary (i.e.
!     have a single degree of freedom). If this is not the case then more
!     covariates might be added at each step
      cip = ip + 1

!     work array to hold the parameter estimates
      Allocate (b(cip))

      If (monit) Then
!       display column headers for monitoring information
        Write (nout,'(3X,A)') 'Covariate    Score'
      End If

!         loop over all possible covariates
score_lp: Do j = 1, m
!       only want to look at covariates included in the selection process
!       (as defined by ISZ(j) >= 1) and those not in the current model
!       (as defined by CISZ(j) = 0)
        If (isz(j)>=1 .And. cisz(j)==0) Then

!         add the covariate being considered to the model
          cisz(j) = 1

!         the order of the values in B must be the same as the order of the 
!         elements of CISZ = 1
          b(1:cip) = pack(ib,cisz(1:m)>=1)

!         quiet exit from NAG routine
          ierr = 1

!         calculate the score function and covariance matrix
!         as we do not want to calculate the parameter estimates but only the
!         values of the other output arguments, set maximum iterations to zero
          Call fit_coxph(z,cisz,t,ic,dev,b,se,sc,cov,res,nd,tp,sur,ierr, &
            maxit=0)
          If (ierr/=0) Then
            info(1) = 2
            info(2) = ierr
            Go To 100
          End If

!         calculate the Score test statistic
          s = score_test_statistic(sc(1:cip),cov)

          If (s>max_s) Then
            max_s = s
            mj = j
          End If

          If (monit) Then
!           display the individual scores
            Write (nout,'(3X,I5,3X,F10.4)') j, s
          End If

!         reset the list of covariates
          cisz(j) = 0
        End If
      End Do score_lp

!     quiet exit from NAG routine
      ierr = 1

!     degrees of freedom. This assumes that the covariates are either continuous
!     or binary (i.e. they have a single degree of freedom). If this is not the
!     case then the calculation of the degrees of freedom would need changing
      df = 1.0_wp

!     get the p-value for MAX_S
      wacc = .False.
      p = g01ecf('Upper',max_s,df,ierr)
      If (ierr/=0) Then
        info(3) = ierr
        If (ierr/=4) Then
          info(1) = 2
          Go To 100
        End If
        info(1) = 1
        wacc = .True.
!       IERR = 4 is an accuracy warning, but the returned value should be 
!       sufficient so continue
      End If

      If (monit) Then
!       print summary information for this iteration
        Write (nout,*)
        Write (nout,'(3X,A,I0,A)') 'Covariate ', mj, &
          ' considered for addition'
        Write (nout,'(7X,A,F10.4)') 'Score   = ', max_s
        Write (nout,'(7X,A,F10.6)') 'p-value = ', p
        If (wacc) Then
          Write (nout,'(10X,A)') &
            'convergence failed in calculation of p-value'
          Write (nout,'(10X,A)') &
            'reported value should be a good approximation'
        End If
        Write (nout,'(7X,A,F10.6)') 'cut-off = ', pa
        Write (nout,*)
      End If

!     check whether the p-value associated with the largest value of S meets
!     the criteria defined by PA
      If (p>pa) Then
        addvar = -1

      Else
        addvar = mj

!       add the covariate to the model
        cisz(mj) = 1
      End If

100   Continue

      Deallocate (b,Stat=ierr)
      Deallocate (se,Stat=ierr)
      Deallocate (sc,Stat=ierr)
      Deallocate (cov,Stat=ierr)
      Deallocate (res,Stat=ierr)
      Deallocate (tp,Stat=ierr)
      Deallocate (sur,Stat=ierr)

      Return
    End Subroutine select_var_to_add

    Subroutine select_var_to_drop(pd,cisz,b,se,dropvar,info,nout,monit)
!     Select a covariate to drop from a Cox proportional hazards model using the
!     Wald statistic and its associated p-value

!     Input:
!     CISZ   - On entry: indicates which subset of covariates are in the current
!              model, with
!               CISZ(j) >= 1 indicating that the jth covariate is in the current
!                           model
!               CISZ(j) = 0  indicating that the jth covariate is not in the
!                           current model
!              On exit: as per entry, but if DROPVAR >= 1, then CISZ(DROPVAR) 
!              will have been set to 0 as well (i.e. on exit CISZ indicates
!              the covariates included in the new model, with covariate
!              indicated by DROPVAR having been dropped)
!     NOUT   - As per BACKWARD_SELECTION, but not optional. Not referenced if
!              MONIT = .FALSE.
!     MONIT  - Logical flag indicating whether monitoring information should
!              be printed to NOUT (.TRUE.) or not (.FALSE.)

!     Output:
!     DROPVAR - The covariate to add to the model, If DROPVAR > 0 then
!               1 <= DROPVAR <= M, where M = SIZE(ISZ,1) (the number 
!               of covariates we have data for). If DROPVAR < 1 then
!               no covariates satisfied the criteria defined by PD
!               and so no covariate was dropped from the model
!     INFO    - As per BACKWARD_SELECTION

!     .. Use Statements ..
      Use nag_library, Only: g01ecf, wp => nag_wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Scalar Arguments ..
      Real (Kind=wp), Intent (In)      :: pd
      Integer, Intent (Out)            :: dropvar
      Integer, Intent (In)             :: nout
      Logical, Intent (In)             :: monit
!     .. Array Arguments ..
      Real (Kind=wp), Intent (In)      :: b(:), se(:)
      Integer, Intent (Inout)          :: cisz(:), info(4)
!     .. Local Scalars ..
      Real (Kind=wp)                   :: df, min_w, p, w
      Integer                          :: ierr, ip, j, m, mj, v
      Logical                          :: wacc
!     .. Intrinsic Procedures ..
      Intrinsic                        :: count, size
!     .. Executable Statements ..
      Continue

!     number of covariates
      m = size(cisz,1)

!     get the number of covariates in the current model
      ip = count(cisz(1:m)>=1)

      If (monit) Then
!       display column headers for monitoring information
        Write (nout,'(3X,A)') 'Covariate    Score'
        v = 0
      End If

!     initialise the variable holding the minimum score (MIN_W), the 
!     associated covariate (MJ) and the variable to drop */
      min_w = -1.0_wp
      mj = 0
      dropvar = -1

!         get the maximum wald score and the associated covariate
score_lp: Do j = 1, ip
!       this method of calculating the Wald statistic is assuming that all of 
!       the covariates are continuous or binary (i.e. they have a single degree
!       freedom). If they do not then the WALD_TEST_STATISTIC routine would 
!       need to be called and this routine would require additional input
        If (se(j)/=0) Then
          w = (b(j)/se(j))**2
          If (w<min_w .Or. min_w<0.0_wp) Then
            min_w = w
            mj = j
          End If
        Else
!         division by zero due to a standard error of zero
!         this should not occur in usual usage
          info(1) = 2
          info(4) = 1
          Go To 100
        End If

        If (monit) Then
!         display the individual scores

!         translate j into the actual covariate ID
m_lp:     Do v = v + 1, m
            If (cisz(v)>=1) Exit m_lp
          End Do m_lp

          Write (nout,'(3X,I5,3X,F10.4)') v, w
        End If

      End Do score_lp

!     quiet exit from NAG routine
      ierr = 1

!     degrees of freedom. This assumes that the covariates are either 
!     continuous or binary (i.e. they have a single degree of freedom). If 
!     this is not the case then the calculation of the degrees of freedom 
!     would need changing
      df = 1.0_wp

!     get the p-value for min_w
      wacc = .False.
      p = g01ecf('Upper',min_w,df,ierr)
      If (ierr/=0) Then
        info(3) = ierr
        If (ierr/=4) Then
          info(1) = 2
          Go To 100
        End If
        info(1) = 1
        wacc = .True.
!       IERR = 4 is an accuracy warning, but the returned value should be 
!       sufficient so continue
      End If

!     find the covariate ID associated with mj
      j = 0
find_id_lp: Do v = 1, m
        If (cisz(v)>=1) j = j + 1
        If (j==mj) Exit find_id_lp
      End Do find_id_lp

      If (monit) Then
!       print summary information for this iteration
        Write (nout,*)
        Write (nout,'(3X,A,I0,A)') 'Covariate ', v, ' considered for removal'
        Write (nout,'(7X,A,F10.4)') 'Score   = ', min_w
        Write (nout,'(7X,A,F10.6)') 'p-value = ', p
        If (wacc) Then
          Write (nout,'(10X,A)') &
            'convergence failed in calculation of p-value'
          Write (nout,'(10X,A)') &
            'reported value should be a good approximation'
        End If
        Write (nout,'(7X,A,F10.6)') 'cut-off = ', pd
        Write (nout,*)
      End If

!     check whether the p-value associated with the largest value of W meets
!     the criteria defined by PD
      If (p<pd) Then
        dropvar = -1

      Else
        dropvar = v

!       drop the covariate associated with largest value of W from the model
        cisz(v) = 0
      End If

100   Continue

      Return
    End Subroutine select_var_to_drop
